Index: lib/TWiki/Plugins.pm
===================================================================
--- lib/TWiki/Plugins.pm	(revision 1767)
+++ lib/TWiki/Plugins.pm	(working copy)
@@ -91,7 +91,7 @@
 sub getPluginVersion
 {
     my ( $thePlugin ) = @_;
-    $thePlugin = TWiki::extractNameValuePair( $thePlugin );
+
     my $version = 0;
     if( $thePlugin ) {
         foreach my $plugin ( @activePlugins ) {
@@ -105,18 +105,10 @@
     return $version;
 }
 
-# =========================
-=pod
-
----++ sub discoverPluginPerlModules ()
-
-Not yet documented.
-
-=cut
-
-sub discoverPluginPerlModules
+# Locate and register all plugins.
+sub _discoverPluginPerlModules
 {
-    my $libDir = &TWiki::getTWikiLibDir();
+    my $libDir = TWiki::getTWikiLibDir();
     my @plugins = ();
     my @modules = ();
     if( opendir( DIR, "$libDir/TWiki/Plugins" ) ) {
@@ -129,49 +121,25 @@
     return @plugins;
 }
 
-# =========================
-=pod
-
----++ sub registerHandler (  $handlerName, $theHandler  )
-
-Not yet documented.
-
-=cut
-
-sub registerHandler
+# Register a plugin handler
+sub _registerHandler
 {
     my ( $handlerName, $theHandler ) = @_;
     push @{$registeredHandlers{$handlerName}}, ( $theHandler );
 }
 
-# =========================
-=pod
-
----++ sub initialisationError 
-
-Internal routine called every time a plugin fails to load
-
-=cut
-
-sub initialisationError 
-{
+# Internal routine called every time a plugin fails to load
+sub _initialisationError {
    my( $error ) = @_;
    $initialisationErrors .= $error."\n";
-   &TWiki::writeWarning( $error );
+   TWiki::writeWarning( $error );
 }
 
-=pod
----++ sub registerPlugin ( $plugin, $topic, $web, $user, $theLoginName, $theUrl, $thePathInfo  )
-
-Not yet documented.
-
-=cut
-
-sub registerPlugin
+# FIXME: make all this sub more robust
+# parameters: ( $plugin, $topic, $web, $user )
+# If $user is empty this is preInitPlugin call - used to establish the user
+sub _registerPlugin
 {
-    #FIXME make all this sub more robust
-    # parameters: ( $plugin, $topic, $web, $user )
-    # If $user is empty this is preInitPlugin call - used to establish the user
     my ( $plugin, $topic, $web, $user, $theLoginName, $theUrl, $thePathInfo ) = @_;
 
     # look for the plugin installation web (needed for attached files)
@@ -183,7 +151,7 @@
 
     # Ignore an empty plugin name (should not happen, fix the calling function!).
 	if ( ! $plugin ) {
-      initialisationError( "Plugins: undefined or empty plugin name" );
+      _initialisationError( "Plugins: undefined or empty plugin name" );
 	  return;
     }
 
@@ -200,18 +168,18 @@
     }
 
     if( ! $installWeb ) {
-        if ( &TWiki::Store::topicExists( $TWiki::twikiWebname, $plugin ) ) {
+        if ( TWiki::Store::topicExists( $TWiki::twikiWebname, $plugin ) ) {
             # found plugin in TWiki web
             $installWeb = $TWiki::twikiWebname;
-        } elsif ( &TWiki::Store::topicExists( "Plugins", $plugin ) ) {
+        } elsif ( TWiki::Store::topicExists( "Plugins", $plugin ) ) {
             # found plugin in Plugins web
             $installWeb = "Plugins";
-        } elsif ( &TWiki::Store::topicExists( $web, $plugin ) ) {
+        } elsif ( TWiki::Store::topicExists( $web, $plugin ) ) {
             # found plugin in current web
             $installWeb = $web;
         } else {
             # not found
-            initialisationError( "Plugins: couldn't register $plugin, no plugin topic" );
+            _initialisationError( "Plugins: couldn't register $plugin, no plugin topic" );
             return;
         }
     }
@@ -220,7 +188,7 @@
     if ( $plugin =~ m/^([A-Za-z0-9_]+Plugin)$/ ) {
         $plugin = $1; 
     } else {
-        initialisationError("$plugin - invalid topic name for plugin");
+        _initialisationError("$plugin - invalid topic name for plugin");
         return;
     }
 
@@ -229,7 +197,7 @@
     eval "use $p;";
 
     if ($@) {
-	initialisationError("Plugin \"$p\" could not be loaded by Perl.  Errors were:\n----\n$@----");
+	_initialisationError("Plugin \"$p\" could not be loaded by Perl.  Errors were:\n----\n$@----");
 	return;
     }
     
@@ -249,33 +217,24 @@
     $sub = $p.'::initPlugin';
     # we register a plugin ONLY if it defines initPlugin AND it returns true 
     if( ! defined( &$sub ) ) {
-        initialisationError("Plugin $p iniPlugin did not return true");
+        _initialisationError("Plugin $p iniPlugin did not return true");
         return;
     }
     # read plugin preferences before calling initPlugin
     $prefix = uc( $plugin ) . "_";
-    &TWiki::Prefs::getPrefsFromTopic( $installWeb, $plugin, $prefix );
+    TWiki::Prefs::getPrefsFromTopic( $installWeb, $plugin, $prefix );
 
     if( &$sub( $topic, $web, $user, $installWeb ) ) {
         foreach $h ( @registrableHandlers ) {
             $sub = $p.'::'.$h;
-            &registerHandler( $h, $sub ) if defined( &$sub );
+            _registerHandler( $h, $sub ) if defined( &$sub );
         }
         $activePluginWebs{$plugin} = $installWeb;
         push( @activePlugins, $plugin );;
     }
 }
 
-# =========================
-=pod
-
----++ sub applyHandlers ()
-
-Not yet documented.
-
-=cut
-
-sub applyHandlers
+sub _applyHandlers
 {
     my $handlerName = shift;
     my $theHandler;
@@ -297,15 +256,13 @@
     return undef;
 }
 
-# =========================
-# Initialisation that is done is done before the user is known
-# Can return a user e.g. if a plugin like SessionPlugin sets the user
-# using initializeUserHandler.
 =pod
 
 ---++ sub initialize1 (  $theTopicName, $theWebName, $theLoginName, $theUrl, $thePathInfo  )
 
-Not yet documented.
+ Initialisation that is done is done before the user is known
+ Can return a user e.g. if a plugin like SessionPlugin sets the user
+ using initializeUserHandler.
 
 =cut
 
@@ -326,10 +283,10 @@
     }
 
     # Get INSTALLEDPLUGINS and DISABLEDPLUGINS variables
-    my $plugin = &TWiki::Prefs::getPreferencesValue( "INSTALLEDPLUGINS" ) || "";
+    my $plugin = TWiki::Prefs::getPreferencesValue( "INSTALLEDPLUGINS" ) || "";
     $plugin =~ s/[\n\t\s\r]+/ /go;
     my @setInstPlugins = grep { /^.+Plugin$/ } split( /,?\s+/ , $plugin );
-    $plugin = &TWiki::Prefs::getPreferencesValue( "DISABLEDPLUGINS" ) || "";
+    $plugin = TWiki::Prefs::getPreferencesValue( "DISABLEDPLUGINS" ) || "";
 	foreach my $p (split( /,?\s+/ , $plugin)) {
 	  if ( $p =~ /^.+Plugin$/ ) {
 		$p =~ s/^.*\.(.*)$/$1/;
@@ -337,7 +294,7 @@
 	  }
 	}
 
-    my @discoveredPlugins = discoverPluginPerlModules();
+    my @discoveredPlugins = _discoverPluginPerlModules();
     my $p = "";
     foreach $plugin ( @setInstPlugins ) {
 	  $p = $plugin;
@@ -356,27 +313,24 @@
 	  $p = $plugin;
 	  $p =~ s/^.*\.(.*)$/$1/o; # cut web
 	  unless( $disabledPlugins{$p} ) {
-		$posUser = registerPlugin( $plugin, $theTopicName, $theWebName, "", $theLoginName, $theUrl, $thePathInfo );
+		$posUser = _registerPlugin( $plugin, $theTopicName, $theWebName, "", $theLoginName, $theUrl, $thePathInfo );
 		if( $posUser ) {
 		  $user = $posUser;
 		}
 	  }
     }
     unless( $user ) {
-        $user = &TWiki::initializeRemoteUser( $theLoginName );
+        $user = TWiki::User::initializeRemoteUser( $theLoginName );
     }
     return $user;
 }
 
 
-# =========================
-# Initialisation that is done is done after the user is known
 =pod
 
 ---++ sub initialize2 (  $theTopicName, $theWebName, $theUser  )
+Initialisation that is done is done after the user is known
 
-Not yet documented.
-
 =cut
 
 sub initialize2
@@ -390,22 +344,13 @@
         $p = $plugin;
         $p =~ s/^.*\.(.*)$/$1/o; # cut web
         unless( $disabledPlugins{$p} ) {
-            registerPlugin( $plugin, @_, $theWebName, $theUser );
+            _registerPlugin( $plugin, @_, $theWebName, $theUser );
         }
     }
 }
 
-# =========================
-=pod
-
-
---++ sub handleFailedPlugins ()
-
-%FAILEDPLUGINS reports reasons why plugins failed to load
-
-=cut
-
-sub handleFailedPlugins
+# %FAILEDPLUGINS reports reasons why plugins failed to load
+sub _handleFAILEDPLUGINS
 {
    my $text;
 
@@ -433,21 +378,14 @@
    return $text;
 }
 
-=pod
----++ sub handlePluginDescription ()
-
-Not yet documented.
-
-=cut
-
-sub handlePluginDescription
+sub _handlePLUGINDESCRIPTIONS
 {
     my $text = "";
     my $line = "";
     my $pref = "";
     foreach my $plugin ( @activePlugins ) {
         $pref = uc( $plugin ) . "_SHORTDESCRIPTION";
-        $line = &TWiki::Prefs::getPreferencesValue( $pref );
+        $line = TWiki::Prefs::getPreferencesValue( $pref );
         if( $line ) {
             $text .= "\t\* $activePluginWebs{$plugin}.$plugin: $line\n"
         }
@@ -456,16 +394,7 @@
     return $text;
 }
 
-# =========================
-=pod
-
----++ sub handleActivatedPlugins ()
-
-Not yet documented.
-
-=cut
-
-sub handleActivatedPlugins
+sub _handleACTIVATEDPLUGINS
 {
     my $text = "";
     foreach my $plugin ( @activePlugins ) {
@@ -475,84 +404,49 @@
     return $text;
 }
 
-# =========================
-# FIXME: This function no longer used: superseded by initialize1.
-# remove on non documentation-only commit.
 =pod
 
----++ sub initializeUserHandler ()
-
-Not yet documented.
-
-=cut
-
-sub initializeUserHandler
-{
-    # Called by TWiki::initialize
-#   my( $theLoginName, $theUrl, $thePathInfo ) = @_;
-
-    unshift @_, ( 'initializeUserHandler' );
-    my $user = &applyHandlers;
-
-    if( ! defined( $user ) ) {
-        $user = &TWiki::initializeRemoteUser( $_[0] );
-    }
-
-    return $user;
-}
-
-# =========================
-=pod
-
 ---++ sub registrationHandler ()
 
-Not yet documented.
+Called by the register script
 
 =cut
 
 sub registrationHandler
 {
-    # Called by the register script
 #    my( $web, $wikiName, $loginName ) = @_;
-    unshift @_, ( 'registrationHandler' );
-    &applyHandlers;
+    _applyHandlers( 'registrationHandler', @_ );
 }
 
-# =========================
 =pod
 
 ---++ sub beforeCommonTagsHandler ()
 
-Not yet documented.
+Called by sub handleCommonTags at the beginning (for cache Plugins only)
 
 =cut
 
 sub beforeCommonTagsHandler
 {
-    # Called by sub handleCommonTags at the beginning (for cache Plugins only)
 #    my( $text, $topic, $theWeb ) = @_;
-    unshift @_, ( 'beforeCommonTagsHandler' );
-    &applyHandlers;
+    _applyHandlers( 'beforeCommonTagsHandler', @_ );
 }
 
-# =========================
 =pod
 
 ---++ sub commonTagsHandler ()
 
-Not yet documented.
+Called by sub handleCommonTags, after %INCLUDE:"..."%
 
 =cut
 
 sub commonTagsHandler
 {
-    # Called by sub handleCommonTags, after %INCLUDE:"..."%
 #    my( $text, $topic, $theWeb ) = @_;
-    unshift @_, ( 'commonTagsHandler' );
-    &applyHandlers;
-    $_[0] =~ s/%PLUGINDESCRIPTIONS%/&handlePluginDescription()/geo;
-    $_[0] =~ s/%ACTIVATEDPLUGINS%/&handleActivatedPlugins()/geo;
-    $_[0] =~ s/%FAILEDPLUGINS%/&handleFailedPlugins()/geo;
+    _applyHandlers( 'commonTagsHandler', @_ );
+    $_[0] =~ s/%PLUGINDESCRIPTIONS%/&_handlePLUGINDESCRIPTIONS()/geo;
+    $_[0] =~ s/%ACTIVATEDPLUGINS%/&_handleACTIVATEDPLUGINS()/geo;
+    $_[0] =~ s/%FAILEDPLUGINS%/&_handleFAILEDPLUGINS()/geo;
 }
 
 # =========================
@@ -560,16 +454,14 @@
 
 ---++ sub afterCommonTagsHandler ()
 
-Not yet documented.
+Called by sub handleCommonTags at the end (for cache Plugins only)
 
 =cut
 
 sub afterCommonTagsHandler
 {
-    # Called by sub handleCommonTags at the end (for cache Plugins only)
 #    my( $text, $topic, $theWeb ) = @_;
-    unshift @_, ( 'afterCommonTagsHandler' );
-    &applyHandlers;
+    _applyHandlers( 'afterCommonTagsHandler', @_ );
 }
 
 # =========================
@@ -577,16 +469,14 @@
 
 ---++ sub startRenderingHandler ()
 
-Not yet documented.
+Called by getRenderedVersion just before the line loop
 
 =cut
 
 sub startRenderingHandler
 {
-    # Called by getRenderedVersion just before the line loop
 #    my ( $text, $web ) = @_;
-    unshift @_, ( 'startRenderingHandler' );
-    &applyHandlers;
+    _applyHandlers( 'startRenderingHandler', @_ );
 }
 
 # =========================
@@ -594,16 +484,14 @@
 
 ---++ sub outsidePREHandler ()
 
-Not yet documented.
+Called by sub getRenderedVersion, in loop outside of <PRE> tag
 
 =cut
 
 sub outsidePREHandler
 {
-    # Called by sub getRenderedVersion, in loop outside of <PRE> tag
 #    my( $text ) = @_;
-    unshift @_, ( 'outsidePREHandler' );
-    &applyHandlers;
+    _applyHandlers( 'outsidePREHandler', @_ );
 }
 
 # =========================
@@ -611,16 +499,14 @@
 
 ---++ sub insidePREHandler ()
 
-Not yet documented.
+Called by sub getRenderedVersion, in loop inside of <PRE> tag
 
 =cut
 
 sub insidePREHandler
 {
-    # Called by sub getRenderedVersion, in loop inside of <PRE> tag
 #    my( $text ) = @_;
-    unshift @_, ( 'insidePREHandler' );
-    &applyHandlers;
+    _applyHandlers( 'insidePREHandler', @_ );
 }
 
 # =========================
@@ -628,16 +514,14 @@
 
 ---++ sub endRenderingHandler ()
 
-Not yet documented.
+Called by getRenderedVersion just after the line loop
 
 =cut
 
 sub endRenderingHandler
 {
-    # Called by getRenderedVersion just after the line loop
 #    my ( $text ) = @_;
-    unshift @_, ( 'endRenderingHandler' );
-    &applyHandlers;
+    _applyHandlers( 'endRenderingHandler', @_ );
 }
 
 # =========================
@@ -645,16 +529,14 @@
 
 ---++ sub beforeEditHandler ()
 
-Not yet documented.
+Called by edit
 
 =cut
 
 sub beforeEditHandler
 {
-    # Called by edit
 #    my( $text, $topic, $web ) = @_;
-    unshift @_, ( 'beforeEditHandler' );
-    &applyHandlers;
+    _applyHandlers( 'beforeEditHandler', @_ );
 }
 
 # =========================
@@ -662,16 +544,14 @@
 
 ---++ sub afterEditHandler ()
 
-Not yet documented.
+Called by edit
 
 =cut
 
 sub afterEditHandler
 {
-    # Called by edit
 #    my( $text, $topic, $web ) = @_;
-    unshift @_, ( 'afterEditHandler' );
-    &applyHandlers;
+    _applyHandlers( 'afterEditHandler', @_ );
 }
 
 # =========================
@@ -679,31 +559,28 @@
 
 ---++ sub beforeSaveHandler ()
 
-Not yet documented.
+Called by TWiki::Store::saveTopic before the save action
 
 =cut
 
 sub beforeSaveHandler
 {
-    # Called by TWiki::Store::saveTopic before the save action
 #    my ( $theText, $theTopic, $theWeb ) = @_;
-    unshift @_, ( 'beforeSaveHandler' );
-    &applyHandlers;
+    _applyHandlers( 'beforeSaveHandler', @_ );
 }
 
 =pod
+
 ---++ sub afterSaveHandler ()
 
-Not yet documented.
+Called by TWiki::Store::saveTopic after the save action
 
 =cut
 
 sub afterSaveHandler
 {
-# Called by TWiki::Store::saveTopic after the save action
 #    my ( $theText, $theTopic, $theWeb ) = @_;
-    unshift @_, ( 'afterSaveHandler' );
-    &applyHandlers;
+    _applyHandlers( 'afterSaveHandler', @_ );
 }
 
 =pod
@@ -738,8 +615,7 @@
 {
     # Called by TWiki::Store::saveAttachment before the save action
 #    my ( $theAttrHash, $theTopic, $theWeb ) = @_;
-    unshift @_, ( 'beforeAttachmentSaveHandler' );
-    &applyHandlers;
+    _applyHandlers( 'beforeAttachmentSaveHandler', @_ );
 }
 
 =pod
@@ -769,8 +645,7 @@
 {
 # Called by TWiki::Store::saveAttachment after the save action
 #    my ( $theText, $theTopic, $theWeb ) = @_;
-    unshift @_, ( 'afterAttachmentSaveHandler' );
-    &applyHandlers;
+    _applyHandlers( 'afterAttachmentSaveHandler', @_ );
 }
 
 
@@ -779,15 +654,13 @@
 
 ---++ sub writeHeaderHandler ()
 
-Not yet documented.
+Called by TWiki::writeHeader
 
 =cut
 
 sub writeHeaderHandler
 {
-    # Called by TWiki::writeHeader
-    unshift @_, ( 'writeHeaderHandler' );
-    return &applyHandlers;
+    return _applyHandlers( 'writeHeaderHandler', @_ );
 }
 
 # =========================
@@ -795,15 +668,13 @@
 
 ---++ sub redirectCgiQueryHandler ()
 
-Not yet documented.
+Called by TWiki::redirect
 
 =cut
 
 sub redirectCgiQueryHandler
 {
-    # Called by TWiki::redirect
-    unshift @_, ( 'redirectCgiQueryHandler' );
-    return &applyHandlers;
+    return _applyHandlers( 'redirectCgiQueryHandler', @_ );
 }
 
 # =========================
@@ -811,15 +682,13 @@
 
 ---++ sub getSessionValueHandler ()
 
-Not yet documented.
+Called by TWiki::getSessionValue
 
 =cut
 
 sub getSessionValueHandler
 {
-    # Called by TWiki::getSessionValue
-    unshift @_, ( 'getSessionValueHandler' );
-    return &applyHandlers;
+    return _applyHandlers( 'getSessionValueHandler', @_ );
 }
 
 # =========================
@@ -827,15 +696,13 @@
 
 ---++ sub setSessionValueHandler ()
 
-Not yet documented.
+Called by TWiki::setSessionValue
 
 =cut
 
 sub setSessionValueHandler
 {
-    # Called by TWiki::setSessionValue
-    unshift @_, ( 'setSessionValueHandler' );
-    return &applyHandlers;
+    return _applyHandlers( 'setSessionValueHandler', @_ );
 }
 
 # ========================
@@ -876,9 +743,7 @@
 
 sub renderFormFieldForEditHandler
 {
-    # Called by Form.TODO
-    unshift @_, ( 'renderFormFieldForEditHandler' );
-    return &applyHandlers;
+    return _applyHandlers( 'renderFormFieldForEditHandler', @_ );
 }
 
 =pod
@@ -893,8 +758,7 @@
 
 sub renderWikiWordHandler
 {
-    unshift @_, ( 'renderWikiWordHandler' );
-    return &applyHandlers;
+    return _applyHandlers( 'renderWikiWordHandler', @_ );
 }
 
 
Index: lib/TWiki/Meta.pm
===================================================================
--- lib/TWiki/Meta.pm	(revision 1767)
+++ lib/TWiki/Meta.pm	(working copy)
@@ -28,9 +28,25 @@
 
 ---+ TWiki::Meta Module
 
-This module reads/writes meta data that describes a topic.
-Data is held as META:FIELD TWiki variables at the start and end of each topic.
+Meta-data handling.
 
+A meta-data object is a hash of different types of meta-data (keyed on
+the type, such as "FIELD" and "TOPICINFO").
+
+Each entry in the hash is an array, where each entry in the array
+contains another hash of the key=value pairs, corresponding to a
+single meta-datum.
+
+If there may be multiple entries of the same top-level type (i.e. for FIELD
+and FILEATTACHMENT) then the array hash multiple entries. Otherwise
+the array has only one entry.
+
+The module knows nothing about how meta-data is stored. That is entirely the
+responsibility of the Store module.
+
+Meta-data objects are created by the Store engine when topics are read. They
+are populated using the =put= method.
+
 =cut
 
 package TWiki::Meta;
@@ -41,27 +57,36 @@
 
 ---++ sub new ()
 
-Not yet documented.
+Construct a new, empty Meta collection.
 
 =cut
 
-sub new
-{
-   my $self = {};
-   bless $self;   
-   return $self;
+sub new {
+    my ( $class, $web, $topic ) = @_;
+    my $self = {};
+    die join(" ", caller) unless $web;
+    die join(" ", caller) unless $topic;
+    $self->{_web} = $web;
+    $self->{_topic} = $topic;
+    bless( $self, $class );
+    return $self;
 }
 
+=pod
+
 # ===========================
 # Replace data for this type.  If type is keyed then only the entry where
-# key matches relavent field is replaced
+# key matches relevant field is replaced
 # Order that args sets are put in is maintained
 =pod
 
 ---++ sub put (  $self, $type, %args  )
 
-Not yet documented.
+Put a hash of key=value pairs into the given type set in this meta.
 
+See the main comment for this package to understand how meta-data is
+represented.
+
 =cut
 
 sub put
@@ -80,7 +105,7 @@
                TWiki::writeWarning( "Meta: Required $key parameter is missing for META:$type" );
                return;
            }
-           for( my $i=0; $i<scalar @$data; $i++ ) {
+           for( my $i = 0; $i < scalar( @$data ); $i++ ) {
                if( $data[$i]->{$key} eq $keyName ) {
                    $data->[$i] = \%args;
                    $found = 1;
@@ -102,34 +127,27 @@
 
 # ===========================
 # Give the key field for a type, "" if no key
-=pod
 
----++ sub _key (  $type  )
-
-Not yet documented.
-
-=cut
-
 sub _key
 {
-   my( $type ) = @_;
-   
-   my $key = "";
-   
-   if( $type eq "FIELD" || $type eq "FILEATTACHMENT" ) {
-       $key = "name";
-   }
+   my $type = shift;
+
+   return "name" if( $type eq "FIELD" || $type eq "FILEATTACHMENT" );
+
+   return undef;
 }
 
 # ===========================
-# Find one meta data item
-# Key needed for some types (see _key)
 =pod
 
----++ sub findOne (  $self, $type, $keyValue  )
+---++ sub findOne (  $self, $type, $key  )
 
-Not yet documented.
+Find the value of a meta-datum in the map. If the type is FIELD or
+FILEATTACHMENT, the $key parameter is required to say _which_
+entry you want. Otherwise it can be undef.
 
+SMELL: This method would be better named "lookup" or "get".
+
 =cut
 
 sub findOne
@@ -158,14 +176,13 @@
    return %args;
 }
 
-# ===========================
-# Get all meta data for a specific type
-# Returns array, zero length if no items
 =pod
 
 ---++ sub find (  $self, $type  )
 
-Not yet documented.
+Get all meta data for a specific type
+Returns the array stored for the type. This will be zero length
+if there are no entries.
 
 =cut
 
@@ -183,16 +200,16 @@
     return @items;
 }
 
-# ===========================
-# If no keyValue, remove all types, otherwise for types
-# with key, just remove specified item. Remove all types
-# if $type is empty.
 =pod
 
----++ sub remove (  $self, $type, $keyValue  )
+---++ sub remove ( $self, $type, $key )
 
-Not yet documented.
+With no type, will remove all the contents of the object.
 
+With a $type but no $key, will remove _all_ items of that type (so for example if $type were FILEATTACHMENT it would remove all of them)
+
+With a $type and a $key it will remove only the specific item.
+
 =cut
 
 sub remove
@@ -220,15 +237,17 @@
     }
 }
 
-# ===========================
-# Copy all entries of a type from another meta data set to self,
-# overwriting the own set
 =pod
 
 ---++ sub copyFrom (  $self, $otherMeta, $type  )
 
-Not yet documented.
+Copy all entries of a type from another meta data set. This
+will destroy the old values for that type, unless the
+copied object doesn't contain entries for that type, in which
+case it will retain the old values.
 
+SMELL: That spec absolutely _STINKS_ !!
+
 =cut
 
 sub copyFrom
@@ -239,129 +258,36 @@
     $self->{$type} = $data if( $data );
 }
 
-# ===========================
-# Number of entries of a given type
 =pod
 
 ---++ sub count (  $self, $type  )
 
-Not yet documented.
+Return the number of entries of the given type that are in this meta set
 
 =cut
 
 sub count
 {
     my( $self, $type ) = @_;
-    
-    my $count = 0;
-    
     my $data = $self->{$type};
-    if( $data ) {
-       $count = scalar @$data;
-    }
-    
-    return $count;
-}
 
-=pod
+    return scalar @$data if( defined( $data ));
 
----++ sub _writeKeyValue (  $key, $value  )
-
-Not yet documented.
-
-=cut
-
-sub _writeKeyValue
-{
-    my( $key, $value ) = @_;
-    
-    $value = cleanValue( $value );
-    
-    my $text = "$key=\"$value\"";
-    
-    return $text;
+    return 0;
 }
 
 =pod
 
----++ sub _writeTypes (  $self, @types  )
+---++ sub restoreValue (  $value  )
 
-Not yet documented.
+Converts %_N_% to a newline and %_Q_% to a " in the string. This is
+part of Meta because it is an operation that is frequently associated
+with meta-data values.
 
-=cut
+SMELL: That isn't a good enough reason!
 
-sub _writeTypes
-{
-    my( $self, @types ) = @_;
-    
-    my $text = "";
-
-    if( $types[0] eq "not" ) {
-        # write all types that are not in the list
-        my %seen;
-        @seen{ @types } = ();
-        @types = ();  # empty "not in list"
-        foreach my $key ( keys %$self ) {
-            push( @types, $key ) unless exists $seen{ $key };
-        }
-    }
-    
-    foreach my $type ( @types ) {
-        my $data = $self->{$type};
-        foreach my $item ( @$data ) {
-            my $sep = "";
-            $text .= "%META:$type\{";
-            my $name = $item->{"name"};
-            if( $name ) {
-                # If there's a name field, put first to make regexp based searching easier
-                $text .= _writeKeyValue( "name", $item->{"name"} );
-                $sep = " ";
-            }
-            foreach my $key ( sort keys %$item ) {
-                if( $key ne "name" ) {
-                    $text .= $sep;
-                    $text .= _writeKeyValue( $key, $item->{$key} );
-                    $sep = " ";
-                }
-            }
-            $text .= "\}%\n";
-         }
-    }
-
-    return $text;
-}
-
-=pod
-
----++ sub cleanValue (  $value  )
-
-Not yet documented.
-
 =cut
 
-sub cleanValue
-{
-    my( $value ) = @_;
-
-    $value =~ s/\r\r\n/%_N_%/go;
-    $value =~ s/\r\n/%_N_%/go;
-    $value =~ s/\n\r/%_N_%/go;
-    $value =~ s/\r\n/%_N_%/go; # Deal with doubles or \n\r
-    $value =~ s/\r/\n/go;
-    $value =~ s/\n/%_N_%/go;
-    $value =~ s/"/%_Q_%/go;
-
-    return $value;
-}
-
-=pod
-
----++ sub restoreValue (  $value  )
-
-Not yet documented.
-
-=cut
-
 sub restoreValue
 {
     my( $value ) = @_;
@@ -372,124 +298,61 @@
     return $value;
 }
 
-
-
-# ======================
 =pod
 
----++ sub _keyValue2Hash (  $args  )
+---++ sub addTopicInfo (  $web, $topic, $rev, $meta, $forceDate, $forceUser  )
 
-Not yet documented.
+Add TOPICINFO type data to the object, as specified by the parameters.
 
 =cut
 
-sub _keyValue2Hash
-{
-    my( $args ) = @_;
-    
-    my %res = ();
-    
-    # Format of data is name="value" name1="value1" [...]
-    while( $args =~ s/\s*([^=]+)=\"([^"]*)\"//o ) {
-        my $key = $1;
-        my $value = $2;
-        $value = restoreValue( $value );
-        $res{$key} = $value;
-    }
-    
-    return %res;
-}
+sub addTopicInfo {
+    my( $self, $web, $topic, $rev, $forceDate, $forceUser ) = @_;
 
-# ===========================
-# Returns text with meta stripped out
-=pod
+    my $time = $forceDate || time();
+    my $user = $forceUser || $TWiki::userName;
 
----++ sub read (  $self, $text  )
-
-Not yet documented.
-
-=cut
-
-sub read
-{
-    my( $self, $text ) = @_;
-    
-    my $newText = "";
-
-    foreach ( split( /\r?\n/, $text ) ) {
-        if( /^%META:([^{]+){(.*)}%$/ ) {   # greedy match for ending "}%"
-            my $type = $1;
-            my $args = $2;
-            my %list = _keyValue2Hash( $args );
-            $self->put( $type, %list );
-        } else {
-            $newText .= "$_\n";
-        }
-    }
-    
-    return $newText;
+    my @args = (
+       "version" => "$rev",
+       "date"    => "$time",
+       "author"  => "$user",
+       "format"  => $TWiki::formatVersion );
+    $self->put( "TOPICINFO", @args );
 }
 
-# ===========================
-# Meta data for start of topic
 =pod
 
----++ sub writeStart (  $self  )
+---++ sub getRevisionInfo ( )
 
-Not yet documented.
+Try and get revision info from the meta information, or, if it is not
+present, kick down to the Store module for the same information.
 
-=cut
+Returns ( $revDate, $author, $rev )
 
-sub writeStart
-{
-    my( $self ) = @_;
-    
-    return $self->_writeTypes( qw/TOPICINFO TOPICPARENT/ );
-}
+Note there is no "1." prefix to the revision number returned.
 
-# ===========================
-# Meta data for end of topic
-=pod
-
----++ sub writeEnd (  $self  )
-
-Not yet documented.
-
 =cut
 
-sub writeEnd
-{
-    my( $self ) = @_;
-    
-    my $text = $self->_writeTypes( qw/FORM FIELD FILEATTACHMENT TOPICMOVED/ );
-    # append remaining meta data
-    $text .= $self->_writeTypes( qw/not TOPICINFO TOPICPARENT FORM FIELD FILEATTACHMENT TOPICMOVED/ );
-    return $text;
-}
+sub getRevisionInfo {
+    my $self = shift;
 
-# ===========================
-# Prepend/append meta data to topic
-=pod
+    my %topicinfo = $self->findOne( "TOPICINFO" );
 
----++ sub write (  $self, $text  )
+    my( $date, $author, $rev );
+    if( %topicinfo ) {
+       $date = $topicinfo{"date"} ;
+       $author = $topicinfo{"author"};
+       my $tmp = $topicinfo{"version"};
+       $tmp =~ /1\.(.*)/o;
+       $rev = $1;
+    } else {
+       # Get data from Store
+       ( $date, $author, $rev ) =
+         TWiki::Store::getRevisionInfo( $self->{_web}, $self->{_topic}, "" );
+    }
+    # writeDebug( "rev = $rev" );
 
-Not yet documented.
-
-=cut
-
-sub write
-{
-    my( $self, $text ) = @_;
-    
-    my $start = $self->writeStart();
-    my $end = $self->writeEnd();
-    $text = $start . "$text";
-    $text =~ s/([^\n\r])$/$1\n/;     # new line is required at end
-    $text .= $end;
-    
-    return $text;
+    return( $date, $author, $rev );
 }
 
-
-
 1;
Index: lib/TWiki/Net.pm
===================================================================
--- lib/TWiki/Net.pm	(revision 1767)
+++ lib/TWiki/Net.pm	(working copy)
@@ -49,7 +49,7 @@
 
 ---++ sub getUrl (  $theHost, $thePort, $theUrl, $theUser, $thePass, $theHeader  )
 
-Not yet documented.
+Get the text at the other end of a URL
 
 =cut
 
@@ -119,7 +119,7 @@
 
 ---++ sub sendEmail (  $theText  )
 
-Not yet documented.
+Send an email specified as MIME format content.
 
 =cut
 
@@ -208,15 +208,6 @@
     return $error;
 }
 
-# =========================
-=pod
-
----++ sub _fixLineLength (  $theAddrs  )
-
-Not yet documented.
-
-=cut
-
 sub _fixLineLength
 {
     my( $theAddrs ) = @_;
@@ -226,15 +217,6 @@
     return $theAddrs;
 }
 
-# =========================
-=pod
-
----++ sub _sendEmailBySendmail (  $theText  )
-
-Not yet documented.
-
-=cut
-
 sub _sendEmailBySendmail
 {
     my( $theText ) = @_;
@@ -247,15 +229,6 @@
     return "ERROR: Can't send mail using TWiki::mailProgram";
 }
 
-# =========================
-=pod
-
----++ sub _sendEmailByNetSMTP (  $from, $toref, $data  )
-
-Not yet documented.
-
-=cut
-
 sub _sendEmailByNetSMTP
 {
     my( $from, $toref, $data ) = @_;
